/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VIsStudygroupRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VIsStudygroup extends TableImpl<VIsStudygroupRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_is_studygroup</code>
     */
    public static final VIsStudygroup V_IS_STUDYGROUP = new VIsStudygroup();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VIsStudygroupRecord> getRecordType() {
        return VIsStudygroupRecord.class;
    }

    /**
     * The column <code>common_dd.v_is_studygroup.key_element</code>.
     */
    public final TableField<VIsStudygroupRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_is_studygroup.dn</code>.
     */
    public final TableField<VIsStudygroupRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    private VIsStudygroup(Name alias, Table<VIsStudygroupRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VIsStudygroup(Name alias, Table<VIsStudygroupRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_is_studygroup" as  SELECT key_element,
          dn
         FROM common_dd.t_core_element_hierarchy
        WHERE (key_parent_element IS NULL);
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_is_studygroup</code> table reference
     */
    public VIsStudygroup(String alias) {
        this(DSL.name(alias), V_IS_STUDYGROUP);
    }

    /**
     * Create an aliased <code>common_dd.v_is_studygroup</code> table reference
     */
    public VIsStudygroup(Name alias) {
        this(alias, V_IS_STUDYGROUP);
    }

    /**
     * Create a <code>common_dd.v_is_studygroup</code> table reference
     */
    public VIsStudygroup() {
        this(DSL.name("v_is_studygroup"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VIsStudygroup as(String alias) {
        return new VIsStudygroup(DSL.name(alias), this);
    }

    @Override
    public VIsStudygroup as(Name alias) {
        return new VIsStudygroup(alias, this);
    }

    @Override
    public VIsStudygroup as(Table<?> alias) {
        return new VIsStudygroup(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsStudygroup rename(String name) {
        return new VIsStudygroup(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsStudygroup rename(Name name) {
        return new VIsStudygroup(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VIsStudygroup rename(Table<?> name) {
        return new VIsStudygroup(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudygroup where(Condition condition) {
        return new VIsStudygroup(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudygroup where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudygroup where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudygroup where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsStudygroup where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsStudygroup where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsStudygroup where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VIsStudygroup where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudygroup whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VIsStudygroup whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
